# LiquibaseDiffTask

Extends \AbstractLiquibaseTask

Task to create the diff between two databases. Will output the changes needed to convert the reference database to the database.

Use \Project#createTask to register a new Task.

author | Stephan Hochdoerfer S.Hochdoerfer@bitExpert.de
version | $Id: 0826f300c75677705c8db520dcfc7ee93fcfdbd9 $
since | 2.4.10
package | phing.tasks.ext.liquibase

### Methods

## Ensure that correct parameters were passed in.

    checkParams() : void

inherited

throws |

## Creates a nested <parameter> tag.

    createParameter() : \LiquibaseParameter

inherited

### Response

`\LiquibaseParameter`

Argument object

## Creates a nested <property> tag.

    createProperty() : \LiquibaseProperty

inherited

### Response

`\LiquibaseProperty`

Argument object

## Executes the given command and returns the output.

    execute( $lbcommand, string $lbparams = '') : string

inherited

throws |

### Arguments

#### $lbcommand

``

#### $lbparams

`string`

the command to execute

### Response

`string`

the output of the executed command

## Returns the textual description of the task

    getDescription() : string

inherited

### Response

`string`

The text description of the task

## Returns the location within the buildfile this task occurs. Used by {@link BuildException} to give detailed error messages.

    getLocation() : \Location

inherited

### Response

`\Location`

The location object describing the position of this task within the buildfile.

## Returns the owning target of this task.

    getOwningTarget() : \Target

inherited

### Response

`\Target`

The target object that owns this task

## Returns a reference to current project

    getProject() : \Project

inherited

### Response

`\Project`

Reference to current porject object

## Returns a name

    getRegisterSlot(string $slotName) : \RegisterSlot

inherited

### Arguments

#### $slotName

`string`

### Response

`\RegisterSlot`

## Returns the wrapper object for runtime configuration

    getRuntimeConfigurableWrapper() : \RuntimeConfigurable

inherited

### Response

`\RuntimeConfigurable`

The wrapper object used by this task

## Returns the name of task, used only for log messages

    getTaskName() : string

inherited

### Response

`string`

Name of this task

## Returns the name of the task under which it was invoked, usually the XML tagname

    getTaskType() : string

inherited

### Response

`string`

The type of this task (XML Tag)

## Called by the parser to let the task initialize properly.

    init()

inherited

Should throw a BuildException if something goes wrong with the build

This is abstract here, but may not be overloaded by subclasses.

throws |

## Logs a message with the given priority.

    log(string $msg, integer $level = \Project::MSG_INFO) : void

inherited

### Arguments

#### $msg

`string`

The message to be logged.

#### $level

`integer`

The message's priority at this message should have

## Called by the project to let the task do it's work. This method may be called more than once, if the task is invoked more than once. For example, if target1 and target2 both depend on target3, then running <em>phing target1 target2</em> will run all tasks in target3 twice.

    main()

inherited abstract

Should throw a BuildException if someting goes wrong with the build

This is abstract here. Must be overloaded by real tasks.

## Configure this task if it hasn't been done already.

    maybeConfigure()

inherited

## Perfrom this task

    perform()

inherited

throws |

## Sets the absolute path to the changelog file to use.

    setChangeLogFile( $changelogFile)

inherited

### Arguments

#### $changelogFile

``

## Whether to check the liquibase return code.

    setCheckreturn(boolean $checkreturn)

inherited

### Arguments

#### $checkreturn

`boolean`

## Sets the Java classpathref.

    setclasspathref( $classpathref)

inherited

### Arguments

#### $classpathref

``

## Sets a textual description of the task

    setDescription(string $desc)

inherited

### Arguments

#### $desc

`string`

The text describing the task

## Sets whether to display the output of the command

    setDisplay(boolean $display)

inherited

### Arguments

#### $display

`boolean`

## Sets the absolute path to liquibase jar.

    setJar( $jar)

inherited

### Arguments

#### $jar

``

## Sets the location within the buildfile this task occurs. Called by the parser to set location information.

    setLocation(\Location $location)

inherited

### Arguments

#### $location

`\Location`

The location object describing the position of this task within the buildfile.

## the name of property to set to output value from exec() call.

    setOutputProperty(string $prop) : void

inherited

### Arguments

#### $prop

`string`

property name

## Sets the owning target this task belongs to.

    setOwningTarget(\Target $target)

inherited

### Arguments

#### $target

`\Target`

## Sets the password to connect to the database.

    setPassword( $password)

inherited

### Arguments

#### $password

``

## References the project to the current component.

    setProject(\Project $project) : void

inherited

### Arguments

#### $project

`\Project`

The reference to the current project

## Sets the password to connect to the refernce database.

    setReferencePassword( $password)

### Arguments

#### $password

``

## Sets the url to connect to the reference database in jdbc style, e.g.

    setReferenceUrl( $url)

`jdbc:postgresql://psqlhost/myrefdatabase`

### Arguments

#### $url

``

## Sets the username to connect to the reference database.

    setReferenceUsername( $username)

### Arguments

#### $username

``

## Sets the wrapper object this task should use for runtime configurable elements.

    setRuntimeConfigurableWrapper(\RuntimeConfigurable $wrapper)

inherited

### Arguments

#### $wrapper

`\RuntimeConfigurable`

The wrapper object this task should use

## Sets the name of this task for log messages

    setTaskName(string $name) : string

inherited

### Arguments

#### $name

`string`

### Response

`string`

A string representing the name of this task for log

## Sets the type of the task. Usually this is the name of the XML tag

    setTaskType( $name)

inherited

### Arguments

#### $name

``

## Sets the url to connect to the database in jdbc style, e.g.

    setUrl( $url)

inherited

`jdbc:postgresql://psqlhost/mydatabase`

### Arguments

#### $url

``

## Sets the username to connect to the database.

    setUsername( $username)

inherited

### Arguments

#### $username

``

### Properties

## referenceUsername

    referenceUsername :

### Type(s)

``

## referencePassword

    referencePassword :

### Type(s)

``

## referenceUrl

    referenceUrl :

### Type(s)

``

## Used for liquibase -Dname=value properties.

    properties :

inherited

### Type(s)

``

## Used to set liquibase --name=value parameters

    parameters :

inherited

### Type(s)

``

## jar

    jar :

inherited

### Type(s)

``

## changeLogFile

    changeLogFile :

inherited

### Type(s)

``

## username

    username :

inherited

### Type(s)

``

## password

    password :

inherited

### Type(s)

``

## url

    url :

inherited

### Type(s)

``

## classpathref

    classpathref :

inherited

### Type(s)

``

## Whether to display the output of the command.

    display : boolean

inherited

True by default to preserve old behaviour

var |

### Type(s)

`boolean`

## Whether liquibase return code can cause a Phing failure.

    checkreturn : boolean

inherited

var |

### Type(s)

`boolean`

## Set true if we should run liquibase with PHP passthru instead of exec.

    passthru :

inherited

### Type(s)

``

## Property name to set with output value from exec call.

    outputProperty : string

inherited

var |

### Type(s)

`string`

## Owning Target object

    target : \Target

inherited

var |

### Type(s)

`\Target`

## Description of the task

    description : string

inherited

var |

### Type(s)

`string`

## Internal taskname (req)

    taskType : string

inherited

var |

### Type(s)

`string`

## Taskname for logger

    taskName : string

inherited

var |

### Type(s)

`string`

## Stored buildfile location

    location : \Location

inherited

var |

### Type(s)

`\Location`

## Wrapper of the task

    wrapper : \RuntimeConfigurable

inherited

var |

### Type(s)

`\RuntimeConfigurable`

## Holds a reference to the project that a project component (a task, a target, etc.) belongs to

    project : \Project

inherited

var | A reference to the current project instance

### Type(s)

`\Project`